﻿Public Class Item
    ' Member variables
    Private strItemNo As String
    Private intStartOnHand As Integer
    Private strInvCode As String
    Private intAmt As Integer
    Private intEndOnHand As Integer
    'Constructor
    Public Sub New()
        Debug.WriteLine("Item object being created.")
        strItemNo = "(unknown)"
        intStartOnHand = 0
        strInvCode = "(unknown)"
        intAmt = 0
        intEndOnHand = 0
    End Sub
    'ItemNo property procedure
    Public Property ItemNo() As String
        Get
            Return strItemNo
        End Get
        Set(ByVal value As String)
            strItemNo = value
        End Set
    End Property
    'OnHand property procedure
    Public Property StartOnHand() As Integer
        Get
            Return intStartOnHand
        End Get
        Set(ByVal value As Integer)
            intStartOnHand = value
        End Set
    End Property
    'InvCode property procedure
    Public Property InvCode() As String
        Get
            Return strInvCode
        End Get
        Set(ByVal value As String)
            strInvCode = value
        End Set
    End Property
    'Amt property procedure
    Public Property Amt() As Integer
        Get
            Return intAmt
        End Get
        Set(ByVal value As Integer)
            intAmt = value
        End Set
    End Property
    'EndOnHand read-only property procedure
    Public ReadOnly Property EndOnHand() As Integer
        Get
            'Determine the ending on hand
            If strInvCode = "S" Then
                intEndOnHand = intStartOnHand - intAmt
            Else
                If strInvCode = "R" Then
                    intEndOnHand = intStartOnHand + intAmt
                Else
                    intEndOnHand = intStartOnHand
                    MessageBox.Show("Invalid inventory code")
                End If
            End If
            'Return the ending on hand
            Return intEndOnHand
        End Get
    End Property
    Protected Overrides Sub Finalize()
        MyBase.Finalize()
        Debug.WriteLine("Inventory object destroyed.")
    End Sub
End Class
