﻿Imports System.IO
Public Class frmInvench12
    'The GetData procedure gets data from the text boxes
    ' and stores it in the object referenced by objItem
    Private Sub GetData(ByVal objItem As Item)
        Try
            'Assign values from the form to the object properties.
            objItem.ItemNo = txtItemNo.Text
            objItem.StartOnHand = CInt(txtStartOnHand.Text)
            objItem.InvCode = txtInvCode.Text
            objItem.Amt = CInt(txtAmt.Text)
        Catch ex As Exception
            'Display an error message
            MessageBox.Show(ex.Message)
        End Try
    End Sub
    Private Sub SaveRecord(ByVal objItem As Item)
        Dim writer As StreamWriter
        Try
            ' Open the file in Append mode
            writer = File.AppendText("Item.txt")
            ' Save the Student object's properties
            writer.WriteLine(objItem.ItemNo)
            writer.WriteLine(objItem.StartOnHand.ToString())
            writer.WriteLine(objItem.InvCode.ToString())
            writer.WriteLine(objItem.Amt.ToString())
            writer.WriteLine(objItem.EndOnHand.ToString())
            ' Close the streamWriter
            writer.Close()
        Catch ex As Exception
            ' Display an error message.
            MessageBox.Show(ex.Message)
        End Try
    End Sub
    'The ClearForm procedure clears the form.
    Private Sub ClearForm()
        txtItemNo.Clear()
        txtStartOnHand.Clear()
        txtInvCode.Clear()
        txtAmt.Clear()
        txtEndOnHand.Clear()
        'Reset the focus
        txtItemNo.Focus()
    End Sub
    Private Sub btnProcess_Click() Handles btnProcess.Click
        ' Create an instance of the Item class.
        Dim objItem As New Item
        'Get data from the form.
        GetData(objItem)
        'Display the item end on hand
        txtEndOnHand.Text = objItem.EndOnHand
        'Save this item record
        SaveRecord(objItem)
        'Confirm that the record was saved
        MessageBox.Show("Item record saved.")
        'Clear the form
        ClearForm()
    End Sub
    Private Sub btnExit_Click() Handles btnExit.Click
        'close the form.
        Me.Close()
    End Sub
    Private Sub frmInvench12_Load() Handles MyBase.Load
        'Enable output to the Output window.
        Debug.Listeners.Add(New ConsoleTraceListener())

    End Sub


End Class
